<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns="http://www.w3.org/TR/REC-html40">
	<xsl:output method="html"/>
	<xsl:template match="/">
		<HTML>
			<HEAD>
				<TITLE>
					<xsl:apply-templates select="//project/name"/> Project Dependencies</TITLE>
			</HEAD>
			<BODY>
				<h1 align="center">
					<xsl:apply-templates select="//project/name"/> Project Dependencies</h1>
				<br/>
				<xsl:apply-templates select="//project/dependencies"/>
			</BODY>
		</HTML>
	</xsl:template>
	<xsl:template match="project/dependencies/dependency">
		<TABLE border="1" width="600">
			<TR>
				<td bgcolor="gray" width="100">
					<strong>Jar Name</strong>
				</td>
				<td>
					<xsl:apply-templates select="artifactId"/>-<xsl:apply-templates select="version"/>.jar</td>
			</TR>
			<TR>
				<td>
					<strong>GroupId</strong>
				</td>
				<td>
					<xsl:apply-templates select="groupId"/>
				</td>
			</TR>
			<TR>
				<td>
					<strong>ArtifactId</strong>
				</td>
				<td>
					<xsl:apply-templates select="artifactId"/>
				</td>
			</TR>
			<TR>
				<td>
					<strong>Version</strong>
				</td>
				<td>
					<xsl:apply-templates select="version"/>
				</td>
			</TR>
			<TR>
				<td>
					<strong>Url</strong>
				</td>
				<td>
					<xsl:apply-templates select="url"/>
				</td>
			</TR>
			<TR>
				<td>
					<strong>Properties</strong>
				</td>
				<td>
					<xsl:apply-templates select="properties"/>
				</td>
			</TR>
		</TABLE>
		<br/>
	</xsl:template>
	<xsl:template match="project/dependencies/dependency/properties">
		<ul>
			<xsl:for-each select="node()">
			   <xsl:if test="string(text())">
				<li>
					<strong>
						<xsl:value-of select="local-name()"/>:</strong>
					<p>
						<xsl:value-of select="text()"/>
					</p>
				</li>
						   </xsl:if>
			</xsl:for-each>
		</ul>
	</xsl:template>
</xsl:stylesheet>
