/*=============================================================================*
 *  Copyright 2005 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/

package org.apache.ws.muse.example;

import javax.xml.namespace.QName;
import java.net.InetAddress;
import java.net.UnknownHostException;

/**
 * @author Kinga Dziembowski
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ExampleConstants
{
   /** DOCUMENT_ME */
   public static String         SERVICES_URL = null;

   /** DOCUMENT_ME */
   public static final String   ADDRESSING_2004_NAMESPACE = "http://schemas.xmlsoap.org/ws/2004/08/addressing";

   /** DOCUMENT_ME */
   public static final String[] KNOWN_RESOURCE_TYPES =
      {
         "HostMachine",
         "BusinessProcess",
         "EnterpriseApplication",
         "IntegrationServer"
      };

   /** DOCUMENT_ME */
   public static final String MUWS_EXT_CAPABILITY_URI =
      "http://ws.apache.org/namespaces/muse/capabilities/muws-ext-1";
   
   /** Owners of the resources - people responsible for   */
   public static final String RES_ADMIN_OWNER = "Joe Smith";
   public static final String HOST_OWNER = "Joane Smith";
   public static final String APPLICATION_OWNER = "Andrew Brown";
   public static final String BUSINESS_P_OWNER = "Maria Red";
   public static final String INT_SERVER_OWNER = "Fred Green";

   /** DOCUMENT_ME */
   public static final QName RELATIONSHIP_RELATION = new QName( "org.apache.ws.muse.example", "Test", "r" );

   static
   {
      init(  );
   }

   /**
    * DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public static String getAddressingNamespace(  )
   {
      return ADDRESSING_2004_NAMESPACE;
   }

   /**
    * DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public static String[] getKnownResourceTypes(  )
   {
      return KNOWN_RESOURCE_TYPES;
   }

   private static void init(  )
   {
      if ( SERVICES_URL == null )
      {
         try
         { //determine the real ip address
            SERVICES_URL = "http://" + InetAddress.getLocalHost(  ).getHostAddress(  ) + ":8080/muse/services";
         }
         catch ( UnknownHostException uhe )
         {
            uhe.printStackTrace(  );
         }
      }
   }
}