/*=============================================================================*
 *  Copyright 2005 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package org.apache.ws.muse.example.businessprocesstype.callback;

import org.apache.ws.muse.example.businessprocesstype.backend.BusinessProcessInstance;
import org.apache.ws.namespaces.muse.muwsExt1.impl.LongMetricImpl;
import org.apache.ws.resource.properties.ResourceProperty;
import org.apache.ws.resource.properties.ResourcePropertyCallback;
import java.util.Calendar;

/**
 * @author Kinga Dziembowski
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class TotalNumberOfCompletedProcessesCallback
   implements ResourcePropertyCallback
{
   /** DOCUMENT_ME */
   BusinessProcessInstance m_instance;

   /**
    * Creates a new {@link TotalNumberOfCompletedProcessesCallback} object.
    *
    * @param instance DOCUMENT_ME
    */
   public TotalNumberOfCompletedProcessesCallback( BusinessProcessInstance instance )
   {
      m_instance = instance;
   }

   /* (non-Javadoc)
    * @see org.apache.ws.resource.properties.ResourcePropertyCallback#refreshProperty(org.apache.ws.resource.properties.ResourceProperty)
    */
   public ResourceProperty refreshProperty( ResourceProperty prop )
   {
      try
      {
         LongMetricImpl metric       = (LongMetricImpl) prop.get( 0 );
         Calendar       calendarInst = Calendar.getInstance(  );
         metric.setLastUpdated( calendarInst );
         metric.setLongValue( m_instance.getTotalNumberOfCompletedProcesses(  ) );
      }
      catch ( Exception re )
      {
         re.printStackTrace(  );
      }

      return prop;
   }
}