/*=============================================================================*
 *  Copyright 2005 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package org.apache.ws.muse.example.application;

import org.apache.ws.resource.ResourceContext;

/**
 * This class should be generated ONCE (and not overwritten) to maintain user-added code.
 * If there is a change to the WSDL, then the generated implemented interfaces
 * (representing the "base" portTypes) will change, thus showing a compile error to the
 * user.
 *
 * NOTE: This class is generated. However, it will not be overwritten by subsequent
 *       calls to the code generator.
 *
 */
public class ApplicationService
   extends AbstractApplicationService
   implements ApplicationCustomOperationsPortType
{
   /**
    * A NamespaceVerionHolder which maintains the QNames of Spec Wsdls
    */
   public static final org.apache.ws.muws.v1_0.impl.WsdmNamespaceVersionHolderImpl SPEC_NAMESPACE_SET =
      new org.apache.ws.muws.v1_0.impl.WsdmNamespaceVersionHolderImpl(  );

   /**
    * Creates a new {@link ApplicationService } object.
    *
    * @param resourceContext DOCUMENT_ME
    */
   public ApplicationService( ResourceContext resourceContext )
   {
      super( resourceContext );
      init(  );
   }


   /**
    * DOCUMENT_ME
    *
    * @param requestDoc DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    *
    * @throws org.apache.ws.muse.example.application.EventsEmitFaultException DOCUMENT_ME
    */
   public org.apache.ws.muse.example.application.properties.StartEventsResponseDocument StartEvents( org.apache.ws.muse.example.application.properties.StartEventsDocument requestDoc )
   throws org.apache.ws.muse.example.application.EventsEmitFaultException
   {
      org.apache.ws.muse.example.application.properties.StartEventsResponseDocument                     responseDocument =
         org.apache.ws.muse.example.application.properties.StartEventsResponseDocument.Factory.newInstance(  );
      org.apache.ws.muse.example.application.properties.StartEventsResponseDocument.StartEventsResponse response  =
         responseDocument.addNewStartEventsResponse(  );
      ApplicationResource                                                                               aResource =
         (ApplicationResource) getResource(  );
      aResource.startEvents( requestDoc.getStartEvents(  ).getDelay(  ),
                             requestDoc.getStartEvents(  ).getFrequency(  ) );
      return responseDocument;
   }

   /**
    * DOCUMENT_ME
    *
    * @param requestDoc DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    *
    * @throws org.apache.ws.muse.example.application.EventsEmitFaultException DOCUMENT_ME
    */
   public org.apache.ws.muse.example.application.properties.StopEventsResponseDocument StopEvents( org.apache.ws.muse.example.application.properties.StopEventsDocument requestDoc )
   throws org.apache.ws.muse.example.application.EventsEmitFaultException
   {
      org.apache.ws.muse.example.application.properties.StopEventsResponseDocument                    responseDocument =
         org.apache.ws.muse.example.application.properties.StopEventsResponseDocument.Factory.newInstance(  );
      org.apache.ws.muse.example.application.properties.StopEventsResponseDocument.StopEventsResponse response  =
         responseDocument.addNewStopEventsResponse(  );
      ApplicationResource                                                                             aResource =
         (ApplicationResource) getResource(  );
      aResource.stopEvents(  );
      return responseDocument;
   }

   /**
    * Returns a collection of Spec Namespaces associated with this Service
    *
    * @return A NamespaceVersionHolder impl which represents the collection of spec namespaces
    *         associated with this service.
    */
   protected org.apache.ws.resource.properties.NamespaceVersionHolder getNamespaceSet(  )
   {
      return SPEC_NAMESPACE_SET;
   }
}