/*=============================================================================*
 *  Copyright 2005 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package org.apache.ws.muse.example.application;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.ws.resource.faults.AbstractBaseFaultException;
import org.apache.ws.resource.i18n.MessagesImpl;
import org.apache.ws.resource.properties.NamespaceVersionHolder;
import org.apache.ws.util.i18n.Messages;
import javax.xml.namespace.QName;

/**
 * **** WARNING: This file will be overwritten during generation ****
 */
public class EventsEmitFaultException
   extends AbstractBaseFaultException
{
   private static final Messages MSG = MessagesImpl.getInstance(  );
   private static final Log      LOG = LogFactory.getLog( EventsEmitFaultException.class );
   private QName                 m_name;

   /**
    * Constructs a new EventsEmitFaultException .
    *
    * @param namespaces
    * @param faultString
    */
   public EventsEmitFaultException( NamespaceVersionHolder namespaces,
                                    String                 faultString )
   {
      super( namespaces, faultString );
      m_name = new QName( "http://ws.apache.org/muse/example/application", "EventsEmitFaultException" );
   }

   /**
    * Returns the element name for this base fault.
    *
    * @return the element name for this base fault
    */
   public QName getBaseFaultName(  )
   {
      return m_name;
   }
}