/*=============================================================================*
 *  Copyright 2005 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package org.apache.ws.muse.example.businessprocesstype;

import org.apache.ws.addressing.EndpointReference;

/**
 * An abstract Businessprocesstype WS-Resource.
 * <p/>
 * NOTE: This class is generated and is NOT meant to be modified.
 */
public abstract class AbstractBusinessprocesstypeResource
        implements org.apache.ws.resource.PropertiesResource,
        org.apache.ws.notification.base.NotificationProducerResource
{
    /**
     * The resource ID of the instance.
     */
    protected String m_id;

    /**
     * The EndpointReference for this resource *
     */
    protected EndpointReference m_endpointReference;

    /**
     * The set of properties associated with this resource.
     */
    protected org.apache.ws.resource.properties.ResourcePropertySet m_propSet;

    /**
     * A list of termination listeners to be notified when the resource is terminated.
     */
    private java.util.List m_terminationListeners = new java.util.ArrayList();

    /**
     * DOCUMENT_ME
     */
    org.apache.ws.notification.topics.TopicSpaceSet m_topicSpaceSet =
            new org.apache.ws.notification.topics.impl.TopicSpaceSetImpl( true );

    /**
     * Sets the EndpointReference associated with this Resource.
     *
     * @param epr The Resource's EndpointReference.
     *            <p/>
     *            Note: It is the responsibility of the Resource creator to set the EndpointReference (i.e. ResourceHome
     *            impl)
     */
    public void setEndpointReference( EndpointReference epr )
    {
        m_endpointReference = epr;
    }

    /**
     * Returns the EndpointReference associated with this Resource.
     *
     * @return The Resource's EndpointReference or null if the EndpointReference has not been set.
     *         <p/>
     *         Note: It is the responsibility of the Resource creator to set the EndpointReference (i.e. ResourceHome
     *         impl)
     */
    public EndpointReference getEndpointReference()
    {
        return m_endpointReference;
    }

    /**
     * DOCUMENT_ME
     *
     * @param id DOCUMENT_ME
     */
    public void setID( Object id )
    {
        if ( m_id != null )
        {
            throw new IllegalStateException( "This resource's ID has already been set." );
        }

        try
        {
            m_id = (String) id;
        }
        catch ( ClassCastException cce )
        {
            throw new IllegalArgumentException( "Specified ID is not a String." );
        }
    }

    /**
     * DOCUMENT_ME
     *
     * @return DOCUMENT_ME
     */
    public Object getID()
    {
        return m_id;
    }

    /**
     * @see org.apache.ws.resource.PropertiesResource#setResourcePropertySet(org.apache.ws.resource.properties.ResourcePropertySet)
     */
    public void setResourcePropertySet( org.apache.ws.resource.properties.ResourcePropertySet propSet )
    {
        m_propSet = propSet;
    }

    /**
     * @see org.apache.ws.resource.PropertiesResource#getResourcePropertySet()
     */
    public org.apache.ws.resource.properties.ResourcePropertySet getResourcePropertySet()
    {
        return m_propSet;
    }

    /**
     * DOCUMENT_ME
     *
     * @return DOCUMENT_ME
     */
    public org.apache.ws.notification.topics.TopicSpaceSet getTopicSpaceSet()
    {
        return m_topicSpaceSet;
    }

    /**
     * DOCUMENT_ME
     *
     * @param listener DOCUMENT_ME
     */
    public void addTerminationListener( org.apache.ws.resource.lifetime.ResourceTerminationListener listener )
    {
        m_terminationListeners.add( listener );
    }

    /**
     * DOCUMENT_ME
     */
    public void destroy()
    {
        org.apache.ws.resource.lifetime.ResourceTerminationEvent rte =
                new org.apache.ws.resource.lifetime.impl.ResourceTerminationEventImpl( getID(), "Resource Destroyed" );
        for ( int i = 0; i < m_terminationListeners.size(); i++ )
        {
            org.apache.ws.resource.lifetime.ResourceTerminationListener resourceTerminationEventListener =
                    (org.apache.ws.resource.lifetime.ResourceTerminationListener) m_terminationListeners.get( i );
            resourceTerminationEventListener.terminationOccurred( rte );
        }
    }

    /**
     * DOCUMENT_ME
     */
    public void init()
    {
        org.apache.ws.muse.example.businessprocesstype.BusinessProcessTypePropertiesDocument propsDoc =
                org.apache.ws.muse.example.businessprocesstype.BusinessProcessTypePropertiesDocument.Factory.newInstance();
        m_propSet = new org.apache.ws.resource.properties.impl.XmlBeansResourcePropertySet( propsDoc );

        org.apache.ws.resource.properties.ResourceProperty topicProp = getResourcePropertySet().get(
                org.apache.ws.notification.base.v2004_06.porttype.NotificationProducerPortType.PROP_QNAME_TOPIC );
        topicProp.setCallback( new org.apache.ws.notification.base.TopicResourcePropertyCallback( getTopicSpaceSet() ) );

        org.apache.ws.resource.properties.ResourceProperty fixedTopicSetProp = getResourcePropertySet().get(
                org.apache.ws.notification.base.v2004_06.porttype.NotificationProducerPortType.PROP_QNAME_FIXED_TOPIC_SET );
        fixedTopicSetProp.setCallback(
                new org.apache.ws.notification.base.FixedTopicSetResourcePropertyCallback( getTopicSpaceSet() ) );

        org.apache.ws.resource.properties.ResourceProperty topicExpressionDialectsProp = getResourcePropertySet().get(
                org.apache.ws.notification.base.v2004_06.porttype.NotificationProducerPortType.PROP_QNAME_TOPIC_EXPRESSION_DIALECTS );
        topicExpressionDialectsProp.setCallback(
                new org.apache.ws.notification.base.TopicExpressionDialectsResourcePropertyCallback() );

        org.apache.ws.muws.MuwsUtils.updateRelationshipResourceProperty( m_propSet, this );
    }
}