/*=============================================================================*
 *  Copyright 2005 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package org.apache.ws.muse.example.businessprocesstype;

import org.apache.ws.muse.example.businessprocesstype.properties.CompleteDocument;
import org.apache.ws.muse.example.businessprocesstype.properties.CompleteResponseDocument;
import org.apache.ws.resource.ResourceContext;

/**
 * 
 * @author Kinga Dziembowski
 * 
 * This class should be generated ONCE (and not overwritten) to maintain user-added code.
 * If there is a change to the WSDL, then the generated implemented interfaces
 * (representing the "base" portTypes) will change, thus showing a compile error to the
 * user.
 *
 * NOTE: This class is generated. However, it will not be overwritten by subsequent
 *       calls to the code generator.
 *
 */
public class BusinessprocesstypeService
   extends AbstractBusinessprocesstypeService
   implements BusinessprocesstypeCustomOperationsPortType
{
   /**
    * A NamespaceVerionHolder which maintains the QNames of Spec Wsdls
    */
   public static final org.apache.ws.muws.v1_0.impl.WsdmNamespaceVersionHolderImpl SPEC_NAMESPACE_SET =
      new org.apache.ws.muws.v1_0.impl.WsdmNamespaceVersionHolderImpl(  );

   /**
    * Creates a new {@link BusinessprocesstypeService } object.
    *
    * @param resourceContext DOCUMENT_ME
    */
   public BusinessprocesstypeService( ResourceContext resourceContext )
   {
      super( resourceContext );
      init(  );
   }

   /**
    * DOCUMENT_ME
    *
    * @param requestDoc DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public org.apache.ws.muse.example.businessprocesstype.properties.ResumeResponseDocument Resume( org.apache.ws.muse.example.businessprocesstype.properties.ResumeDocument requestDoc )
   {
      org.apache.ws.muse.example.businessprocesstype.properties.ResumeResponseDocument  responseDocument =
         org.apache.ws.muse.example.businessprocesstype.properties.ResumeResponseDocument.Factory.newInstance(  );
      org.apache.ws.muse.example.businessprocesstype.properties.ResumeResponseDocument.ResumeResponse response  =
         responseDocument.addNewResumeResponse(  );
      BusinessprocesstypeResource aResource =(BusinessprocesstypeResource) getResource(  );
      aResource.resume( requestDoc.getResume(  ) );
      return responseDocument;
   }

   /**
    * DOCUMENT_ME
    *
    * @param requestDoc DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public org.apache.ws.muse.example.businessprocesstype.properties.SuspendResponseDocument Suspend( org.apache.ws.muse.example.businessprocesstype.properties.SuspendDocument requestDoc )
   {
      org.apache.ws.muse.example.businessprocesstype.properties.SuspendResponseDocument                 responseDocument =
         org.apache.ws.muse.example.businessprocesstype.properties.SuspendResponseDocument.Factory.newInstance(  );
      org.apache.ws.muse.example.businessprocesstype.properties.SuspendResponseDocument.SuspendResponse response  =
         responseDocument.addNewSuspendResponse(  );
      BusinessprocesstypeResource                                                                       aResource =
         (BusinessprocesstypeResource) getResource(  );
      aResource.suspend( requestDoc.getSuspend(  ) );
      return responseDocument;
   }

   /**
    * DOCUMENT_ME
    *
    * @param requestDoc DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public org.apache.ws.muse.example.businessprocesstype.properties.TerminateResponseDocument Terminate( org.apache.ws.muse.example.businessprocesstype.properties.TerminateDocument requestDoc )
   {
      org.apache.ws.muse.example.businessprocesstype.properties.TerminateResponseDocument                   responseDocument =
         org.apache.ws.muse.example.businessprocesstype.properties.TerminateResponseDocument.Factory.newInstance(  );
      org.apache.ws.muse.example.businessprocesstype.properties.TerminateResponseDocument.TerminateResponse response  =
         responseDocument.addNewTerminateResponse(  );
      BusinessprocesstypeResource                                                                           aResource =
         (BusinessprocesstypeResource) getResource(  );
      aResource.terminate( requestDoc.getTerminate(  ) );

      return responseDocument;
   }

   /**
    * Returns a collection of Spec Namespaces associated with this Service
    *
    * @return A NamespaceVersionHolder impl which represents the collection of spec namespaces
    *         associated with this service.
    */
   protected org.apache.ws.resource.properties.NamespaceVersionHolder getNamespaceSet(  )
   {
      return SPEC_NAMESPACE_SET;
   }

/* (non-Javadoc)
 * @see org.apache.ws.muse.example.businessprocesstype.BusinessprocesstypeCustomOperationsPortType#Complete(org.apache.ws.muse.example.businessprocesstype.properties.CompleteDocument)
 */
public CompleteResponseDocument Complete(CompleteDocument requestDoc) {
	org.apache.ws.muse.example.businessprocesstype.properties.CompleteResponseDocument responseDocument =
        org.apache.ws.muse.example.businessprocesstype.properties.CompleteResponseDocument.Factory.newInstance(  );
     org.apache.ws.muse.example.businessprocesstype.properties.CompleteResponseDocument.CompleteResponse response  =
        responseDocument.addNewCompleteResponse(  );
     BusinessprocesstypeResource aResource = (BusinessprocesstypeResource) getResource(  );
     aResource.complete( requestDoc.getComplete(  ) );

     return responseDocument;
}
}