package org.apache.ws.resource.example.filesystem;


/**
 * **** NOTE: This file will not be overwritten during generation ****
 * <p/>
 * A Filesystem WS-Resource.
 * <p/>
 * NOTE: This class is generated but IS meant to be modified.
 */
public class FilesystemResource extends AbstractFilesystemResource

{

    /**
     * A NamespaceVerionHolder which maintains the QNames of Spec Wsdls
     */
    public static final org.apache.ws.muws.v1_0.impl.WsdmNamespaceVersionHolderImpl SPEC_NAMESPACE_SET = new org.apache.ws.muws.v1_0.impl.WsdmNamespaceVersionHolderImpl();

    private static final String HOST_HOME_LOCATION =
     org.apache.ws.resource.JndiConstants.CONTEXT_NAME_SERVICES + "/host/" + org.apache.ws.resource.JndiConstants.ATOMIC_NAME_HOME;

    private example.filesystem.backend.FileSystem m_filesystem;

    /**
     * Initializes this resource's state (properties, etc.).
     */
    public void init()
    {
        super.init();

        /*
         * This is where you should associate the backend instance with
         * the resource instance for a given id.
         */
        m_filesystem = new example.filesystem.backend.UnixFileSystem( m_id );

        /*
         * Add MUWS "capability topics" to the topic set.
         */
        org.apache.ws.muws.v1_0.topics.ManagementEventTopic identityCapabilityTopic;
        org.apache.ws.muws.v1_0.topics.ManagementEventTopic manageabilityCharacteristicsCapabilityTopic;
        org.apache.ws.muws.v1_0.topics.ManagementEventTopic operationalStatusCapabilityTopic;
        org.apache.ws.muws.v1_0.topics.ManagementEventTopic relationshipsCapabilityTopic;
        try
        {
            org.apache.ws.notification.topics.TopicSpace muwsTopicSpace = new org.apache.ws.notification.topics.impl.TopicSpaceImpl( org.apache.ws.muws.v1_0.MuwsConstants.NSURI_MUWS_PART2_TOPICS );
            getTopicSpaceSet().addTopicSpace( muwsTopicSpace );

            identityCapabilityTopic = new org.apache.ws.muws.v1_0.topics.impl.XmlBeansManagementEventTopicImpl( org.apache.ws.muws.v1_0.capability.IdentityCapability.TOPIC_NAME );
            muwsTopicSpace.addTopic( identityCapabilityTopic );
            manageabilityCharacteristicsCapabilityTopic = new org.apache.ws.muws.v1_0.topics.impl.XmlBeansManagementEventTopicImpl(
                    org.apache.ws.muws.v1_0.capability.ManageabilityCharacteristicsCapability.TOPIC_NAME );
            muwsTopicSpace.addTopic( manageabilityCharacteristicsCapabilityTopic );
            operationalStatusCapabilityTopic = new org.apache.ws.muws.v1_0.topics.impl.XmlBeansManagementEventTopicImpl(
                    org.apache.ws.muws.v1_0.capability.OperationalStatusCapability.TOPIC_NAME );
            muwsTopicSpace.addTopic( operationalStatusCapabilityTopic );
            relationshipsCapabilityTopic = new org.apache.ws.muws.v1_0.topics.impl.XmlBeansManagementEventTopicImpl( org.apache.ws.muws.v1_0.capability.RelationshipsCapability.TOPIC_NAME );
            muwsTopicSpace.addTopic( relationshipsCapabilityTopic );
        }
        catch ( Exception e )
        {
            throw new RuntimeException( "Failed to add MUWS capability topics to topic set of " + this.getClass().getName() + " resource with ID " + getID() + ".", e );
        }

        org.apache.ws.resource.properties.ResourcePropertySet resourcePropertySet = getResourcePropertySet();
        org.apache.ws.resource.properties.ResourceProperty resourceProperty;
        try
        {
            /*
	         * Initialize each of our properties by calling resourceProperty.add(propElem) and/or resourceProperty.setCallback(callback)...
	         */
            resourceProperty = resourcePropertySet.get( FilesystemPropertyQNames.DEVICESPECIALFILE );
            DeviceSpecialFileDocument deviceDocXBean = DeviceSpecialFileDocument.Factory.newInstance();
            deviceDocXBean.setDeviceSpecialFile( m_filesystem.getDeviceSpecialFile() );
            resourceProperty.add( deviceDocXBean );

            resourceProperty = resourcePropertySet.get( FilesystemPropertyQNames.TYPE );
            TypeDocument typeDocXBean = TypeDocument.Factory.newInstance();
            typeDocXBean.setType( m_filesystem.getType() );
            resourceProperty.add( typeDocXBean );

            BackupFrequencyDocument backupDocXBean = BackupFrequencyDocument.Factory.newInstance();
            backupDocXBean.setBackupFrequency( m_filesystem.getBackupFrequency() );
            resourceProperty = resourcePropertySet.get( FilesystemPropertyQNames.BACKUPFREQUENCY );
            resourceProperty.add( backupDocXBean );
            resourceProperty.setCallback( new example.filesystem.callback.BackupFrequencyCallback( m_filesystem ) );

            CommentDocument commentDocXBean = CommentDocument.Factory.newInstance();
            commentDocXBean.setComment( m_filesystem.getComment() );
            resourceProperty = resourcePropertySet.get( FilesystemPropertyQNames.COMMENT );
            resourceProperty.add( commentDocXBean );
            resourceProperty.setCallback( new example.filesystem.callback.CommentCallback( m_filesystem ) );

            FsckPassNumberDocument fsckDocXBean = FsckPassNumberDocument.Factory.newInstance();
            fsckDocXBean.setFsckPassNumber( m_filesystem.getFsckPassNumber() );
            resourceProperty = resourcePropertySet.get( FilesystemPropertyQNames.FSCKPASSNUMBER );
            resourceProperty.add( fsckDocXBean );
            resourceProperty.setCallback( new example.filesystem.callback.FsckPassNumberCallback( m_filesystem ) );

            MountPointDirectoryDocument mountPointDocXBean = MountPointDirectoryDocument.Factory.newInstance();
            mountPointDocXBean.setMountPointDirectory( m_filesystem.getMountPoint() );
            resourceProperty = resourcePropertySet.get( FilesystemPropertyQNames.MOUNTPOINTDIRECTORY );
            resourceProperty.add( mountPointDocXBean );
            resourceProperty.setCallback( new example.filesystem.callback.MountPointCallback( m_filesystem ) );

            OptionsDocument optionsDocXBean =
                    OptionsDocument.Factory.newInstance();
            org.apache.ws.resource.example.filesystem.OptionsDocument.Options options =
                    optionsDocXBean.addNewOptions();
            java.util.List backendOptions =
                    m_filesystem.getOptions();
            for ( int i = 0; i < backendOptions.size(); i++ )
            {
                options.addOption( (String) backendOptions.get( i ) );
            }

            resourceProperty = resourcePropertySet.get( FilesystemPropertyQNames.OPTIONS );
            resourceProperty.add( optionsDocXBean );
            resourceProperty.setCallback( new example.filesystem.callback.OptionsCallback( m_filesystem ) );

            /*
             * MUWS-defined properties.
             */
            // init the {http://docs.oasis-open.org/wsdm/2004/12/muws/wsdm-muws-part1.xsd}ResourceId resource property
            org.apache.ws.muws.MuwsUtils.initResourceIdProperty(this);
            // NOTE: it's not necessary to add a property change listener, since the ResourceId prop is immutable

            // init the {http://docs.oasis-open.org/wsdm/2004/12/muws/wsdm-muws-part1.xsd}ManageabilityCapability resource property
            resourceProperty = resourcePropertySet.get( FilesystemPropertyQNames.MANAGEABILITYCAPABILITY );
            // add property element for MUWS Identity capability...
            org.oasisOpen.docs.wsdm.x2004.x12.muws.wsdmMuwsPart1.ManageabilityCapabilityDocument identityCapabilityPropElem = org.oasisOpen.docs.wsdm.x2004.x12.muws.wsdmMuwsPart1.ManageabilityCapabilityDocument.Factory.newInstance();
            identityCapabilityPropElem.setManageabilityCapability( org.apache.ws.muws.v1_0.capability.IdentityCapability.URI );
            resourceProperty.add( identityCapabilityPropElem );
            // add property element for MUWS ManageabilityCharacteristics capability...
            org.oasisOpen.docs.wsdm.x2004.x12.muws.wsdmMuwsPart1.ManageabilityCapabilityDocument manageabilityCharacteristicsCapabilityPropElem = org.oasisOpen.docs.wsdm.x2004.x12.muws.wsdmMuwsPart1.ManageabilityCapabilityDocument.Factory.newInstance();
            manageabilityCharacteristicsCapabilityPropElem.setManageabilityCapability(
                    org.apache.ws.muws.v1_0.capability.ManageabilityCharacteristicsCapability.URI );
            resourceProperty.add( manageabilityCharacteristicsCapabilityPropElem );
            // add property element for MUWS OperationalStatus capability...
            org.oasisOpen.docs.wsdm.x2004.x12.muws.wsdmMuwsPart1.ManageabilityCapabilityDocument operationalStatusCapabilityPropElem = org.oasisOpen.docs.wsdm.x2004.x12.muws.wsdmMuwsPart1.ManageabilityCapabilityDocument.Factory.newInstance();
            operationalStatusCapabilityPropElem.setManageabilityCapability( org.apache.ws.muws.v1_0.capability.OperationalStatusCapability.URI );
            resourceProperty.add( operationalStatusCapabilityPropElem );
            // add property element for MUWS Relationships capability...
            org.oasisOpen.docs.wsdm.x2004.x12.muws.wsdmMuwsPart1.ManageabilityCapabilityDocument relationshipsCapabilityPropElem = org.oasisOpen.docs.wsdm.x2004.x12.muws.wsdmMuwsPart1.ManageabilityCapabilityDocument.Factory.newInstance();
            relationshipsCapabilityPropElem.setManageabilityCapability( org.apache.ws.muws.v1_0.capability.RelationshipsCapability.URI );
            resourceProperty.add( relationshipsCapabilityPropElem );
            // NOTE: it's not necessary to add a property change listener, since the ManageabilityCapability prop is immutable

            // init the {http://docs.oasis-open.org/wsdm/2004/12/muws/wsdm-muws-part2.xsd}OperationalStatus resource property
            resourceProperty = resourcePropertySet.get( FilesystemPropertyQNames.OPERATIONALSTATUS );
            org.oasisOpen.docs.wsdm.x2004.x12.muws.wsdmMuwsPart2.OperationalStatusDocument statusDoc = org.oasisOpen.docs.wsdm.x2004.x12.muws.wsdmMuwsPart2.OperationalStatusDocument.Factory.newInstance();
            statusDoc.setOperationalStatus( org.oasisOpen.docs.wsdm.x2004.x12.muws.wsdmMuwsPart2.OperationalStatusDocument.OperationalStatus.AVAILABLE );
            resourceProperty.add(statusDoc);
            resourceProperty.setCallback( new example.filesystem.callback.OperationalStatusCallback( m_filesystem ) );
            resourceProperty.addChangeListener( operationalStatusCapabilityTopic ); // add for property-value-changed management events

            // init the {http://docs.oasis-open.org/wsdm/2004/12/muws/wsdm-muws-part2.xsd}Relationship resource property
            resourceProperty = resourcePropertySet.get( FilesystemPropertyQNames.RELATIONSHIP );
            org.oasisOpen.docs.wsdm.x2004.x12.muws.wsdmMuwsPart2.RelationshipDocument prop_relationship = org.oasisOpen.docs.wsdm.x2004.x12.muws.wsdmMuwsPart2.RelationshipDocument.Factory.newInstance();
            /*
             * Create the relationship bean...
             */
            org.oasisOpen.docs.wsdm.x2004.x12.muws.wsdmMuwsPart2.RelationshipType relationshipType = null;
            relationshipType = prop_relationship.addNewRelationship();
            org.oasisOpen.docs.wsdm.x2004.x12.muws.wsdmMuwsPart2.RelationshipTypeType relationshipTypeType = relationshipType.addNewType();
            org.apache.ws.util.XmlBeanUtils.addChildElement( relationshipTypeType, new javax.xml.namespace.QName( "http://myns.com/", "ContainedBy", "myns" ) );


            org.oasisOpen.docs.wsdm.x2004.x12.muws.wsdmMuwsPart2.RelationshipParticipantType relationshipParticipantType = relationshipType.addNewParticipant();
            org.apache.ws.resource.properties.ResourceProperty resourceIdProp = resourcePropertySet.get( FilesystemPropertyQNames.RESOURCEID );
            org.apache.xmlbeans.XmlAnyURI resourceId = (org.apache.xmlbeans.XmlAnyURI) resourceIdProp.get( 0 );
            relationshipParticipantType.setResourceId( resourceId.getStringValue() );
            relationshipParticipantType.setRole( "urn:containee" );
            // NOTE: the below line assumes that the Filesystem resource's EndpointReference field has been initialized
            org.xmlsoap.schemas.ws.x2004.x08.addressing.EndpointReferenceType filesystemReference = (org.xmlsoap.schemas.ws.x2004.x08.addressing.EndpointReferenceType) ((org.apache.ws.addressing.XmlBeansEndpointReference)getEndpointReference()).getXmlObject( org.apache.ws.addressing.v2004_08_10.AddressingConstants.NSURI_ADDRESSING_SCHEMA );
            relationshipParticipantType.setManageabilityEndpointReferenceArray( new org.xmlsoap.schemas.ws.x2004.x08.addressing.EndpointReferenceType[] { filesystemReference } );

            org.oasisOpen.docs.wsdm.x2004.x12.muws.wsdmMuwsPart2.RelationshipParticipantType relationshipParticipantType2 = relationshipType.addNewParticipant();
            org.apache.ws.resource.ResourceHome hostHome = (org.apache.ws.resource.ResourceHome) new javax.naming.InitialContext( ).lookup( HOST_HOME_LOCATION );
            org.apache.ws.resource.PropertiesResource host = (org.apache.ws.resource.PropertiesResource) hostHome.find( null ); // host is a singleton resource w/ a null resource identifier
            resourceIdProp = host.getResourcePropertySet().get( org.apache.ws.muws.v1_0.capability.IdentityCapability.PROP_NAME_RESOURCE_ID );
            resourceId = (org.apache.xmlbeans.XmlAnyURI) resourceIdProp.get( 0 );
            relationshipParticipantType2.setResourceId( resourceId.getStringValue() );
            relationshipParticipantType2.setRole( "urn:container" );
            // NOTE: the below line assumes that the Host resource's EndpointReference field has been initialized
            org.xmlsoap.schemas.ws.x2004.x08.addressing.EndpointReferenceType hostReference = (org.xmlsoap.schemas.ws.x2004.x08.addressing.EndpointReferenceType) ((org.apache.ws.addressing.XmlBeansEndpointReference)host.getEndpointReference()).getXmlObject( org.apache.ws.addressing.v2004_08_10.AddressingConstants.NSURI_ADDRESSING_SCHEMA );
            relationshipParticipantType.setManageabilityEndpointReferenceArray( new org.xmlsoap.schemas.ws.x2004.x08.addressing.EndpointReferenceType[] { hostReference } );

            resourceProperty.add( prop_relationship );
            resourceProperty.addChangeListener( relationshipsCapabilityTopic ); // add for property-value-changed management events
        }
        catch ( Exception e )
        {
            throw new RuntimeException( "There was a problem in initializing your resource properties.  Please check your init() method. Cause: " +
                    e.getLocalizedMessage() );
        }

        // Resource Property {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd}TerminationTime is implemented by the framework.
        // Resource Property {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd}CurrentTime is implemented by the framework.
        // Resource Property {http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd}FixedTopicSet is implemented by the framework.
        // Resource Property {http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd}Topic is implemented by the framework.
        // Resource Property {http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd}TopicExpressionDialects is implemented by the framework.

        /**
         * This method enables the ResourceTermination Topic for notifications
         * about this resource's termination.  If you would not like this
         * behaviour either comment or remove the line of code.
         */
        try
        {
            org.apache.ws.notification.topics.util.TopicUtils.addResourceTerminationTopic( getTopicSpaceSet(), this,
                    SPEC_NAMESPACE_SET );
        }
        catch ( Exception e )
        {
            throw new RuntimeException(
                    "Unable to init the ResourceTermination topic. Cause: " + e.getLocalizedMessage(), e );
        }

        /**
         * This method call will make all resource properties be exposed
         * as Topics.  If you would like to change that behaviour you can
         * call TopicUtils.addResourcePropertyValueChangeTopic for each
         * Topic you'd like to expose property change notifications for.
         */
        try
        {
            org.apache.ws.notification.topics.util.TopicUtils.addResourcePropertyValueChangeTopics(
                    getResourcePropertySet(), getTopicSpaceSet() );
        }
        catch ( Exception e )
        {
            throw new RuntimeException(
                    "Unable to init the ResourceProperty Changed topics. Cause: " + e.getLocalizedMessage(), e );
        }

    }

    public void mount() throws Exception
    {
        m_filesystem.mount();
    }

    public void unmount() throws Exception
    {
        m_filesystem.unmount();
    }

    public boolean isMounted()
    {
        return m_filesystem.isMounted();
    }

}
