
package org.apache.ws.resource.example.host;

import org.apache.ws.resource.Resource;
import org.apache.ws.resource.ResourceContext;
import org.apache.ws.resource.ResourceContextException;
import org.apache.ws.resource.ResourceException;
import org.apache.ws.resource.ResourceUnknownException;
import org.apache.ws.resource.impl.AbstractResourceHome;
import org.apache.ws.addressing.EndpointReference;

import javax.xml.namespace.QName;

import java.io.Serializable;

/**
 * The home for Host resources.
 * <p />
 * NOTE: This file is generated, but is meant to be modified.
 *       It will NOT be overwritten by subsequent runs of Wsdl2Java.
 */
public class HostHome
        extends AbstractHostHome
        implements Serializable
{

    /**  The service endpoint name as registered with the SOAP Platform.  This is useful for building EPR's. **/
    public static final QName SERVICE_NAME = javax.xml.namespace.QName.valueOf("{http://ws.apache.org/resource/example/host}host");

    /** The management PortType associated with this resource. This is useful for building EPR's.**/
    public static final QName PORT_TYPE = javax.xml.namespace.QName.valueOf("{http://ws.apache.org/resource/example/host}HostPortType");

    /** The WSDL Port name associated with the resource. This is useful for building EPR's. **/
    public static final String PORT_NAME = "host";

    /** The name of the resource key for this resource. **/
    public static final QName RESOURCE_KEY_NAME = javax.xml.namespace.QName.valueOf("{http://ws.apache.org/resource/example/host}ResourceIdentifier");

        /**
     * A NamespaceVerionHolder which maintains the QNames of Spec Wsdls
     */
     public static final org.apache.ws.muws.v1_0.impl.WsdmNamespaceVersionHolderImpl SPEC_NAMESPACE_SET = new org.apache.ws.muws.v1_0.impl.WsdmNamespaceVersionHolderImpl();
        /** A constant for the JNDI Lookup name for this home. **/
    public static final String  HOME_LOCATION =
     org.apache.ws.resource.JndiConstants.CONTEXT_NAME_SERVICES + "/" + SERVICE_NAME.getLocalPart() + "/" + org.apache.ws.resource.JndiConstants.ATOMIC_NAME_HOME;

    /**
     * Create and add any resource instances.
     *
     * @throws Exception on error
     */
    public void init() throws Exception
    {
        super.init();
        add( createInstance( null ) );

    }

    public QName getServiceName()
    {
        return SERVICE_NAME;
    }

    public QName getPortType()
    {
        return PORT_TYPE;
    }

    public String getServicePortName()
    {
        return PORT_NAME;
    }

    public QName getResourceKeyNameQName()
    {
        return RESOURCE_KEY_NAME;
    }

    public org.apache.ws.resource.properties.NamespaceVersionHolder getNamespaceVersionHolder()
    {
        return SPEC_NAMESPACE_SET;
    }

}
