/*
 * Created on Jun 8, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.apache.interop.smgr;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.InterruptedIOException;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.SocketTimeoutException;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;
import java.util.TimeZone;

/**
 * @author wire
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class NotificationListener implements Runnable {
    private static final String HTTP_SERVER_NAME = "WS-NotificationConsumer/1.0";
    private static final String HTTP_VERSION = "1.0";
    private static final String HTTP_STATUS = "202 Accepted";
    private boolean closeSocketAfterNotification=true;
    private ServerSocket server ;
    int port;
    int timeout;
    final Object listenerStarted = new Object();
    private static final DateFormat HTTP_DATE_FORMAT = new SimpleDateFormat(
            "EEE, dd MMM yyyy HH:mm:ss zzz", Locale.US );
    StringBuffer retIncomingMessage;
    static
    {
        HTTP_DATE_FORMAT.setTimeZone( TimeZone.getTimeZone( "GMT" ) );
    }
    public void setCloseSocketAfterNotification(boolean value){
    	closeSocketAfterNotification=value;
    }
    /**
     * the buffer to store the incoming message
     */
    private StringBuffer m_incomingMessage;
    private Thread listener;
	private BufferedReader bufIn;
	private BufferedOutputStream bufOut;
	private Socket sock;
    public Object getMessageSemaphore(){
    	return listenerStarted;
    }
    
	/**
	 * 
	 */
	public NotificationListener(int port,int timeout,StringBuffer retIncomingMessage) {
		super();
		this.port=port;
		this.timeout=timeout;
		this.retIncomingMessage=retIncomingMessage;		
	}
	
	public void stop(){
		listener.interrupt();
        if ( server != null )
        {
            try
            {
            	if(sock!=null)
            		synchronized(sock){	
            		sock.notifyAll();
            	}
	              if(bufIn!=null)
	              	bufIn.close();
	              if(bufOut!=null)
	              	bufOut.close();
	              if(server!=null)
	              	server.close();
            }
            catch ( IOException ignored )
            {
            }
        }

	}
	
	public void start() throws IOException{
	       // start listening and then return when the thread has officially gone live
        // and the socket is ready to be accepted
	    listener = new Thread(this,"Notification Listener");
		
        synchronized ( listenerStarted )
        {
            listener.start();

//            try
//            {
//                listenerStarted.wait();
//            }
//            catch ( InterruptedException ignored )
//            {
//            }
            //return controll to the caller
        }

	}
	
	/* (non-Javadoc)
	 * @see java.lang.Runnable#run()
	 */
	public void run() {
 
            server = null;
            sock = null;
			bufIn = null;
			bufOut = null;
			byte[] responseBytes=null;
            try {
				server = new ServerSocket( port );
	               //server.setSoTimeout( timeout );

	                // let the outer method know that we have started and just about to block on the accept
	                synchronized ( listenerStarted )
	                {
	                    listenerStarted.notify();
	                }

			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				return;
			}

			while(true){
			
				try
	            {	
						System.out.println("Going into accepting state");
	                	sock = server.accept();
	                
	                bufIn = new BufferedReader(
	                        new InputStreamReader( sock.getInputStream() ) );
	                bufOut = new BufferedOutputStream( sock.getOutputStream() );
	                String header=readHeader(bufIn);
	                
	                HttpHeader headerObj=new HttpHeader(header);
				    String content_length = headerObj.getHeader(HttpHeader.CONTENT_LENGTH);
				    int size = Integer.parseInt(content_length);
				    System.out.println("Waiting on "+size+" bytes");
	                responseBytes = buildResponse().toString().getBytes();
	                Thread.sleep(1000);
	                try
                  {

	                    synchronized ( retIncomingMessage )
	                    {
	                        char[] buffer = new char[size];
	                        bufIn.read( buffer, 0, size) ;
	                        {
	                            retIncomingMessage.append( buffer, 0, size );
	                        }
	                    }
                  }
                  catch ( InterruptedIOException ignored )
                  {
                  }

	              bufOut.write( responseBytes, 0, responseBytes.length );
	              bufOut.flush();
	              bufIn.close();
	              bufOut.close();
	              if(closeSocketAfterNotification){
	              	sock.close();
	              	System.out.println("This notification socket has been closed.");
	              }
	              		
	            }    
	            catch ( InterruptedIOException ignored )
	            {
	            	ignored.printStackTrace();
	            	System.out.println("Notification Listener Has Exited.");
	            	return;
	            }
	            catch ( Throwable t )
	            {
	                synchronized ( retIncomingMessage )
	                {
	                    retIncomingMessage.delete( 0,
	                            retIncomingMessage.length() );
	                    retIncomingMessage.append( "ERROR: " );
	                    retIncomingMessage.append( t );
	                }
	            }
	            finally
	            {
	                synchronized ( retIncomingMessage )
	                {
	                    // make sure something goes in the message, even if nothing was received
	                    if ( retIncomingMessage.length() == 0 )
	                    {
	                        retIncomingMessage.append( "ERROR: incoming message was empty" );
	                    }
	
	                    retIncomingMessage.notify();
	                    try {
							retIncomingMessage.wait();
						} catch (InterruptedException e1) {
							// TODO Auto-generated catch block
							System.out.println("Notification Worker Exiting");
							return;
						//	e1.printStackTrace();
						}
	                    retIncomingMessage.setLength(0);

	                }
	                
	//                if ( server != null )
	//                {
	//                    try
	//                    {
	//                        server.close();
	//                    }
	//                    catch ( IOException ignored )
	//                    {
	//                    }
	//                }
	
	                // do this as a fail safe
	                synchronized ( listenerStarted )
	                {
	                    listenerStarted.notify();
	                }
	                

	            }
			}

        }

        /**
	 * @param bufIn2
	 */
	private String readHeader(BufferedReader streamIn) throws IOException {
		// TODO Auto-generated method stub
        char LF=10;
        char NL=13;
      	int lastread = -1;
      	int input = -1;
      	StringBuffer header = new StringBuffer();
    	
      	 String str = streamIn.readLine(); 
         while (!str.equals("")){
           str = streamIn.readLine();
           header.append(str);
           header.append("\n");
           //header.append(LF);
         }
      	
    	return header.toString();
		
	}

		/**
         * Build a one-way HTTP response message that complies to the WS-I Basic Profile 1.0, section 5.6.10
         * - see http://www.ws-i.org/Profiles/BasicProfile-1.0-2004-04-16.html#refinement16651160
         *
         * @return a WS-I-compliant Notify response message
         */
        private String buildResponse()
        {
            Date timeNow = new Date();
            Date sameTimeTomorrow = new Date( timeNow.getTime() + ( 24 * 60 * 60 * 1000 ) );
            StringBuffer responseBuf = new StringBuffer( "HTTP/" );
            responseBuf.append( HTTP_VERSION );
            responseBuf.append( " " );
            responseBuf.append( HTTP_STATUS );
            responseBuf.append( "\r\n" );

            responseBuf.append( "Date: " );
            responseBuf.append( HTTP_DATE_FORMAT.format( timeNow ) );
            responseBuf.append( "\r\n" );

            responseBuf.append( "Server: " );
            responseBuf.append( HTTP_SERVER_NAME );
            responseBuf.append( "\r\n" );

            responseBuf.append( "Cache-Control: " );
            responseBuf.append( "max-age=86400" );
            responseBuf.append( "\r\n" );

            responseBuf.append( "Expires: " );
            responseBuf.append( HTTP_DATE_FORMAT.format( sameTimeTomorrow ) );
            responseBuf.append( "\r\n" );

            return responseBuf.toString();
        }

         
}
