/*
 * Created on May 23, 2005
 *
 */
package org.apache.wsdm.interop.wcm.impl;

import java.net.URL;

import org.apache.wsdm.interop.wcm.impl.ui.WcJFrame;
import org.apache.wsdm.interop.wcm.model.IWcm;
import org.apache.wsdm.interop.wcm.model.IWs;


/**
 * @author wire
 *
 */
public class WcmImpl implements IWcm {
	private URL wcUrl;
	private boolean showUi;
	private WcJFrame wcUI;
	private IWcm app;
	
	/**
	 * @param wcUrl
	 * @param showUi
	 */
	public WcmImpl(URL wcUrl, boolean showUi) {
		super();
		this.wcUrl = wcUrl;
		this.showUi = showUi;
		if(showUi)
			buildUI();
	}

	/**
	 * 
	 */
	private void buildUI() {
		wcUI=new WcJFrame();
		app=(IWcm)wcUI;
		wcUI.show();
	}

	/* (non-Javadoc)
	 * @see com.hp.wsdm.interop.wcm.IWcm#setCurrentTempurature(int)
	 */
	public void setCurrentTempurature(int temp) {
		app.setCurrentTempurature(temp);
		System.out.println("The temp is "+temp);
	}

	/* (non-Javadoc)
	 * @see com.hp.wsdm.interop.wcm.IWcm#setCurrentCost(float)
	 */
	public void setCurrentCost(double cost) {
		app.setCurrentCost(cost);
		
	}

	/* (non-Javadoc)
	 * @see com.hp.wsdm.interop.wcm.IWcm#setCurrentBackup(java.lang.String)
	 */
	public void setCurrentBackup(String backupName) {
		app.setCurrentBackup(backupName);
		
	}

	/* (non-Javadoc)
	 * @see com.hp.wsdm.interop.wcm.IWcm#setCurrentMessage(java.lang.String, java.lang.String)
	 */
	public void setCurrentMessage(String request, String response) {
		app.setCurrentMessage(request,response);
		
	}

	/* (non-Javadoc)
	 * @see com.hp.wsdm.interop.wcm.IWcm#setServiceModel(com.hp.wsdm.interop.wcm.IWs[])
	 */
	public void setServiceModel(IWs[] services) {
		app.setServiceModel(services);		
	}
	

}
