/*
 * Created on May 23, 2005
 *
 */
package org.apache.wsdm.interop.wcm.simulator;

import java.net.URL;

import org.apache.wsdm.interop.wcm.model.IWc;
import org.apache.wsdm.interop.wcm.model.IWs;
import org.apache.wsdm.interop.wcm.model.WcmFactory;


import junit.framework.TestCase;

/**
 * @author wire
 *
 */
public class InteropSimulatorTest extends TestCase {

	private InteropSimulator sim;

	/*
	 * @see TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		super.setUp();
		sim=new InteropSimulator(WcmFactory.createWcm(new URL("http://localhost:8080/wsdm/wc"),false));
	}

	/*
	 * @see TestCase#tearDown()
	 */
	protected void tearDown() throws Exception {
		super.tearDown();
	}

	public void testGetNextTempValue() {
		int firstValue = sim.getNextTempValue();
		assertTrue(firstValue<101);
		assertTrue(firstValue>-1);
		
		int value2 = sim.getNextTempValue();
		assertTrue(Math.abs(firstValue-value2)<=5);
		int value3 = sim.getNextTempValue();
		assertTrue(Math.abs(value3-value2)<=5);
	}

	public void testGetRandomMessage() {
		String message=sim.getRandomMessage();
		assertTrue("Failed with length="+message.length() ,message.length()<101);
		assertTrue(message.length()>0);
	}
	
	public void testBuildModel(){
		IWs[] model = sim.buildModel(2,10,new int[]{1,0,1,1,1,0,1,0,1,0});
		assertEquals(10,model.length);
		assertTrue(model[0] instanceof IWc);
		//assertEquals(model[1],model[9].getBackup());
	}

}
