package org.wsdmdemo.service.weatherStation;

import org.oasisOpen.docs.wsdm.x2004.x12.muws.wsdmMuwsPart2.OperationalStatusDocument;
import org.wsdmdemo.service.InteropConstants;


/**
 * @author Sal Campana
 */
public class OpStatusChanger implements Runnable
{
    private WeatherStationService m_weatherStation;


    public OpStatusChanger(WeatherStationService weatherStationService)
    {
        m_weatherStation = weatherStationService;
    }

    /**
     * When an object implementing interface <code>Runnable</code> is used
     * to create a thread, starting the thread causes the object's
     * <code>run</code> method to be called in that separately executing
     * thread.
     * <p/>
     * The general contract of the method <code>run</code> is that it may
     * take any action whatsoever.
     *
     * @see Thread#run()
     */
    public void run()
    {
        try
        {
            Thread.sleep(InteropConstants.OPERATIONAL_STATUS_RESET_INTERVAL);
        }
        catch (InterruptedException e)
        {
            ;
        }

        m_weatherStation.changeOperationalStatus(OperationalStatusDocument.OperationalStatus.AVAILABLE);

    }
}
