package org.wsdmdemo.service.weatherStation;

import org.apache.ws.resource.impl.AbstractResourceHome;
import org.wsdmdemo.service.InteropConstants;

import javax.xml.namespace.QName;
import java.io.Serializable;
import java.util.Map;

/**
 * **** NOTE: This file will not be overwritten during generation ****
 * <p/>
 * Home for WeatherStation WS-Resources.
 */
public class WeatherStationHome
        extends AbstractResourceHome
        implements Serializable
{

    /**
     * The service endpoint name as registered with the SOAP Platform.  This is useful for building EPR's. *
     */
    public static final QName SERVICE_NAME = javax.xml.namespace.QName.valueOf("{http://wsdmdemo.org/service/weather-station}WeatherStation");

    /**
     * The management PortType associated with this resource. This is useful for building EPR's.*
     */
    public static final QName PORT_TYPE = javax.xml.namespace.QName.valueOf("{http://wsdmdemo.org/service/weather-station}WeatherStationPortType");

    /**
     * The WSDL Port name associated with the resource. This is useful for building EPR's. *
     */
    public static final String PORT_NAME = "weather-station";

    /**
     * The name of the resource key for this resource. *
     */
    public static final QName RESOURCE_KEY_NAME = javax.xml.namespace.QName.valueOf("{http://wsdmdemo.org/service/weather-station}ResourceIdentifier");

    /**
     * A NamespaceVerionHolder which maintains the QNames of Spec Wsdls
     */
    public static final org.apache.ws.muws.v1_0.impl.WsdmNamespaceVersionHolderImpl SPEC_NAMESPACE_SET = new org.apache.ws.muws.v1_0.impl.WsdmNamespaceVersionHolderImpl();
    /**
     * A constant for the JNDI Lookup name for this home. *
     */
    public static final String HOME_LOCATION =
            org.apache.ws.resource.JndiConstants.CONTEXT_NAME_SERVICES + "/" + SERVICE_NAME.getLocalPart() + "/" + org.apache.ws.resource.JndiConstants.ATOMIC_NAME_HOME;

    public void init() throws Exception
    {
        super.init();
        WeatherStationResource ws1 = (WeatherStationResource) createInstance( InteropConstants.WS1_KEY );
        ws1.setName( "IBM's Space Co." );
        add( ws1 );
        WeatherStationResource ws2 = (WeatherStationResource) createInstance( InteropConstants.WS2_KEY );
        ws2.setName( "HP's NASA" );
        add( ws2 );
    }

    public QName getServiceName()
    {
        return SERVICE_NAME;
    }

    public QName getPortType()
    {
        return PORT_TYPE;
    }

    public String getServicePortName()
    {
        return PORT_NAME;
    }

    public QName getResourceKeyNameQName()
    {
        return RESOURCE_KEY_NAME;
    }

    /**
     * Map containing all FilesystemResource instances - this map <em>must</em> be static for
     * compatibility with certain JNDI providers.
     */
    private static Map s_resources;

    /**
     * Returns a map of all FilesystemResource instances. Used by the {@link org.apache.ws.resource.impl.AbstractResourceHome}
     * superclass.
     */
    protected synchronized final Map getResourceMap()
    {
        if ( s_resources == null )
        {
            s_resources = AbstractResourceHome.createResourceMap( m_resourceIsPersistent );
        }
        return s_resources;
    }
    public org.apache.ws.resource.properties.NamespaceVersionHolder getNamespaceVersionHolder()
    {
        return SPEC_NAMESPACE_SET;
    }

}
