package org.wsdmdemo.service.weatherStation.callbacks;

import org.apache.ws.resource.properties.ResourceProperty;
import org.apache.ws.resource.properties.ResourcePropertyCallback;
import org.apache.ws.resource.properties.impl.CallbackFailedException;
import org.wsdmdemo.service.InteropConstants;
import org.wsdmdemo.service.weatherStation.HumidityMetricType;

import java.util.Calendar;


/**
 * @author Sal Campana
 */
public class HumidityCallback implements ResourcePropertyCallback
{
    private double m_lastTemp = InteropConstants.DEFAULT_HUMIDITY;

    public ResourceProperty refreshProperty(ResourceProperty resourceProperty) throws CallbackFailedException
    {
        Calendar resetAt = Calendar.getInstance();
        HumidityMetricType prop_humidity = (HumidityMetricType) resourceProperty.get(0);
        prop_humidity.setDoubleValue(CallbackUtils.getNextRandomValue(m_lastTemp, InteropConstants.MAX_HUMIDITY, InteropConstants.MIN_HUMIDITY));
        prop_humidity.setResetAt(resetAt);
        return resourceProperty;
    }
}
