package org.wsdmdemo.service.weatherStation.callbacks;

import org.apache.ws.resource.properties.ResourceProperty;
import org.apache.ws.resource.properties.ResourcePropertyCallback;
import org.apache.ws.resource.properties.impl.CallbackFailedException;
import org.wsdmdemo.service.InteropConstants;
import org.wsdmdemo.service.weatherStation.TemperatureMetricType;

import java.util.Calendar;


/**
 * @author Sal Campana
 */
public class TemperatureCallback implements ResourcePropertyCallback
{
    private double m_lastTemp = InteropConstants.DEFAULT_TEMP;

    public ResourceProperty refreshProperty(ResourceProperty resourceProperty) throws CallbackFailedException
    {
        Calendar resetAt = Calendar.getInstance();
        TemperatureMetricType prop_temperature = (TemperatureMetricType) resourceProperty.get(0);
        prop_temperature.setDoubleValue(CallbackUtils.getNextRandomValue(m_lastTemp, InteropConstants.MAX_TEMP, InteropConstants.MIN_TEMP));
        prop_temperature.setResetAt(resetAt);
        return resourceProperty;
    }
}
