package org.wsdmdemo.service.weatherStationDir;

import org.apache.ws.addressing.XmlBeansEndpointReference;
import org.apache.ws.addressing.v2004_08_10.AddressingConstants;
import org.apache.ws.resource.PropertiesResource;
import org.apache.ws.resource.ResourceContext;
import org.apache.ws.resource.properties.ResourceProperty;
import org.apache.ws.resource.properties.ResourcePropertySet;
import org.oasisOpen.docs.wsdm.x2004.x12.muws.wsdmMuwsPart2.RelationshipDocument;
import org.oasisOpen.docs.wsdm.x2004.x12.muws.wsdmMuwsPart2.RelationshipParticipantType;
import org.oasisOpen.docs.wsdm.x2004.x12.muws.wsdmMuwsPart2.RelationshipType;
import org.wsdmdemo.service.InteropConstants;
import org.wsdmdemo.service.InteropRequestUtils;
import org.xmlsoap.schemas.ws.x2004.x08.addressing.EndpointReferenceType;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * **** NOTE: This file will not be overwritten during generation ****
 * <p/>
 * This class should be generated ONCE (and not overwritten) to maintain user-added code.
 * If there is a change to the WSDL, then the generated implemented interfaces
 * (representing the "base" portTypes) will change, thus showing a compile error to the
 * user.
 * <p/>
 * NOTE: This class is generated. However, it will not be overwritten by subsequent
 * calls to the code generator.
 */
public class  WeatherStationDirService
        extends AbstractWeatherStationDirService
        implements WeatherStationDirCustomOperationsPortType
{
    /**
     * A NamespaceVerionHolder which maintains the QNames of Spec Wsdls
     */
    public static final org.apache.ws.muws.v1_0.impl.WsdmNamespaceVersionHolderImpl SPEC_NAMESPACE_SET = new org.apache.ws.muws.v1_0.impl.WsdmNamespaceVersionHolderImpl();

    /**
     * Creates a new {@link WeatherStationDirService } object.
     *
     * @param resourceContext DOCUMENT_ME
     */
    public WeatherStationDirService(ResourceContext resourceContext)
    {
        super(resourceContext);
        init();
    }

    /**
     * Returns a collection of Spec Namespaces associated with this Service
     *
     * @return A NamespaceVersionHolder impl which represents the collection of spec namespaces
     *         associated with this service.
     */
    protected org.apache.ws.resource.properties.NamespaceVersionHolder getNamespaceSet()
    {
        return SPEC_NAMESPACE_SET;
    }


    public org.wsdmdemo.service.weatherStationDir.RemoveWeatherStationResponseDocument RemoveWeatherStation(org.wsdmdemo.service.weatherStationDir.RemoveWeatherStationDocument requestDoc)
    {
        org.wsdmdemo.service.weatherStationDir.RemoveWeatherStationResponseDocument responseDocument = org.wsdmdemo.service.weatherStationDir.RemoveWeatherStationResponseDocument.Factory.newInstance();
        org.wsdmdemo.service.weatherStationDir.RemoveWeatherStationResponseDocument.RemoveWeatherStationResponse response = responseDocument.addNewRemoveWeatherStationResponse();

        //remove a relationship
        ResourcePropertySet resourcePropertySet = ((PropertiesResource) getResource()).getResourcePropertySet();
        ResourceProperty resourceProperty = resourcePropertySet.get(WeatherStationDirPropertyQNames.RELATIONSHIP);

        org.wsdmdemo.service.weatherStationDir.RemoveWeatherStationDocument.RemoveWeatherStation removeWeatherStation = requestDoc.getRemoveWeatherStation();
        String resourceId = removeWeatherStation.getResourceId();

        //iterate the relationships
        Iterator iterator = resourceProperty.iterator();
        List removeList = new ArrayList();
        while (iterator.hasNext())
        {
            RelationshipDocument relationshipDocument = (RelationshipDocument) iterator.next();
            RelationshipParticipantType[] participantArray = relationshipDocument.getRelationship().getParticipantArray();

            for (int i = 0; i < participantArray.length; i++)
            {
                RelationshipParticipantType relationshipParticipantType = participantArray[i];
                if (resourceId != null && resourceId.equals(relationshipParticipantType.getResourceId()))
                {
                    removeList.add(relationshipDocument); //add to list to be removed
                }
            }
        }

        for (int i = 0; i < removeList.size(); i++)
        {
            resourceProperty.remove((RelationshipDocument) removeList.get(i));//remove it from the document
        }
        return responseDocument;
    }


    public org.wsdmdemo.service.weatherStationDir.AddWeatherStationResponseDocument AddWeatherStation(org.wsdmdemo.service.weatherStationDir.AddWeatherStationDocument requestDoc)
    {
        org.wsdmdemo.service.weatherStationDir.AddWeatherStationResponseDocument responseDocument = org.wsdmdemo.service.weatherStationDir.AddWeatherStationResponseDocument.Factory.newInstance();
        org.wsdmdemo.service.weatherStationDir.AddWeatherStationResponseDocument.AddWeatherStationResponse response = responseDocument.addNewAddWeatherStationResponse();

        ResourcePropertySet resourcePropertySet = ((PropertiesResource) getResource()).getResourcePropertySet();
        ResourceProperty resourceProperty = resourcePropertySet.get(WeatherStationDirPropertyQNames.RELATIONSHIP);

        //get the request epr
        org.wsdmdemo.service.weatherStationDir.AddWeatherStationDocument.AddWeatherStation addWeatherStation = requestDoc.getAddWeatherStation();
        org.xmlsoap.schemas.ws.x2004.x08.addressing.EndpointReferenceType addedEpr = addWeatherStation.getEndpointReference();

        //define a relationship
        RelationshipDocument relationshipDocument = RelationshipDocument.Factory.newInstance();


        //define the relationship type
        RelationshipType relationshipType = InteropRequestUtils.createRelationshipType(relationshipDocument.addNewRelationship());


        //add self as a participant
        RelationshipParticipantType parentRelationshipParticipantType = relationshipType.addNewParticipant();
        WeatherStationDirResource resource = (WeatherStationDirResource) getResource();
        XmlBeansEndpointReference xmlEpr = (XmlBeansEndpointReference) resource.getEndpointReference();
        EndpointReferenceType dirEndpointReferenceType = (EndpointReferenceType) xmlEpr.getXmlObject(AddressingConstants.NSURI_ADDRESSING_SCHEMA);
        parentRelationshipParticipantType.setResourceId(InteropConstants.DIR_RESOURCEID);
        parentRelationshipParticipantType.setRole(InteropConstants.PARENT_RELATION);//uri
        parentRelationshipParticipantType.setManageabilityEndpointReferenceArray(new EndpointReferenceType[]{dirEndpointReferenceType});


        //add the new ws as the other participant
        RelationshipParticipantType childRelationshipParticipantType = relationshipType.addNewParticipant();
        childRelationshipParticipantType.setResourceId(InteropRequestUtils.getResourceId(addedEpr));
        childRelationshipParticipantType.setRole(InteropConstants.CHILD_RELATION);//uri
        childRelationshipParticipantType.setManageabilityEndpointReferenceArray(new EndpointReferenceType[]{addedEpr});

        resourceProperty.add(relationshipDocument);

        return responseDocument;
    }


}
