package com.dell.wsdm.demos.interop.x2005.x04;

import org.apache.ws.muws.v1_0.capability.ConfigurationCapability;
import org.apache.ws.muws.v1_0.capability.IdentityCapability;
import org.apache.ws.muws.v1_0.capability.OperationalStatusCapability;
import org.oasisOpen.docs.wsdm.x2004.x12.muws.wsdmMuwsPart1.ManageabilityCapabilityDocument;
import org.oasisOpen.docs.wsdm.x2004.x12.muws.wsdmMuwsPart1.ResourceIdDocument;
import org.oasisOpen.docs.wsdm.x2004.x12.muws.wsdmMuwsPart2.CurrentTimeDocument;
import org.oasisOpen.docs.wsdm.x2004.x12.muws.wsdmMuwsPart2.OperationalStatusDocument;

import java.util.Calendar;

/**
 * A Ipmiserver WS-Resource.
 * <p/>
 * NOTE: This class is generated but IS meant to be modified.
 */
public class IpmiserverResource extends AbstractIpmiserverResource

{
    /**
     * A NamespaceVerionHolder which maintains the QNames of Spec Wsdls
     */
    public static final org.apache.ws.muws.v1_0.impl.WsdmNamespaceVersionHolderImpl SPEC_NAMESPACE_SET = new org.apache.ws.muws.v1_0.impl.WsdmNamespaceVersionHolderImpl();

    /**
     * Initializes this resource's state (properties, etc.).
     */
    public void init()
    {
        super.init();

        /**
         * The ResourcePropertySet which contains all the defined ResourceProperties
         */
        org.apache.ws.resource.properties.ResourcePropertySet resourcePropertySet = getResourcePropertySet();
        org.apache.ws.resource.properties.ResourceProperty resourceProperty = null;

        try
        {

            /*===== Capabilities =====*/
            //Management Characteristics
            resourceProperty = resourcePropertySet.get(IpmiserverPropertyQNames.MANAGEABILITYCAPABILITY);

            //muws:Identity Capability
            ManageabilityCapabilityDocument manageabilityCapabilityDocument = ManageabilityCapabilityDocument.Factory.newInstance();
            manageabilityCapabilityDocument.setManageabilityCapability(IdentityCapability.URI);
            resourceProperty.add(manageabilityCapabilityDocument);

            //muws:OperationalStatus Capability
            manageabilityCapabilityDocument = ManageabilityCapabilityDocument.Factory.newInstance();
            manageabilityCapabilityDocument.setManageabilityCapability(OperationalStatusCapability.URI);
            resourceProperty.add(manageabilityCapabilityDocument);

            //muws:Configuration Capability
            manageabilityCapabilityDocument = ManageabilityCapabilityDocument.Factory.newInstance();
            manageabilityCapabilityDocument.setManageabilityCapability(ConfigurationCapability.URI);
            resourceProperty.add(manageabilityCapabilityDocument);

            //Server Configuration
            manageabilityCapabilityDocument = ManageabilityCapabilityDocument.Factory.newInstance();
            manageabilityCapabilityDocument.setManageabilityCapability(IpmiserverPropertyQNames.ATTENTIONLEDON.getNamespaceURI() + "/ServerConfiguration");
            resourceProperty.add(manageabilityCapabilityDocument);

            //Server Chassis Configuration
            manageabilityCapabilityDocument = ManageabilityCapabilityDocument.Factory.newInstance();
            manageabilityCapabilityDocument.setManageabilityCapability(IpmiserverPropertyQNames.ATTENTIONLEDON.getNamespaceURI() + "/ServerChassisConfiguration");
            resourceProperty.add(manageabilityCapabilityDocument);

            //Server Alert Status
            manageabilityCapabilityDocument = ManageabilityCapabilityDocument.Factory.newInstance();
            manageabilityCapabilityDocument.setManageabilityCapability(IpmiserverPropertyQNames.ATTENTIONLEDON.getNamespaceURI() + "/ServerAlertStatus");
            resourceProperty.add(manageabilityCapabilityDocument);

            /*===== Properties =====*/
            resourceProperty = resourcePropertySet.get(IpmiserverPropertyQNames.RESOURCEID);
            ResourceIdDocument resourceIdDocument = ResourceIdDocument.Factory.newInstance();
            resourceIdDocument.setResourceId("urn:" + (String) getID());
            resourceProperty.add(resourceIdDocument);

            // CurrentTime is done like in WSRF
            resourceProperty = resourcePropertySet.get(IpmiserverPropertyQNames.CURRENTTIME);
            CurrentTimeDocument currentTimeDocument = CurrentTimeDocument.Factory.newInstance();
            currentTimeDocument.setCurrentTime(Calendar.getInstance());
            resourceProperty.add(currentTimeDocument);
            resourceProperty.setCallback(new org.apache.ws.resource.lifetime.callback.CurrentTimeCallback());

            resourceProperty = resourcePropertySet.get(IpmiserverPropertyQNames.OPERATIONALSTATUS);
            OperationalStatusDocument operationalStatusDocument = OperationalStatusDocument.Factory.newInstance();
            operationalStatusDocument.setOperationalStatus(OperationalStatusDocument.OperationalStatus.AVAILABLE);
            resourceProperty.add(operationalStatusDocument);

            /*============= Custom props =============*/
            resourceProperty = resourcePropertySet.get(IpmiserverPropertyQNames.ATTENTIONLEDON);
            AttentionLedOnDocument attentionLedOnDoc = AttentionLedOnDocument.Factory.newInstance();
            attentionLedOnDoc.setAttentionLedOn(false);  // NOTE: in an ideal world, we would make an IPMI API call to get the value for this prop
            resourceProperty.add(attentionLedOnDoc);

            resourceProperty = resourcePropertySet.get(IpmiserverPropertyQNames.COVEROPEN);
            CoverOpenDocument coverOpenDoc = CoverOpenDocument.Factory.newInstance();
            coverOpenDoc.setCoverOpen(false);  // NOTE: in an ideal world, we would make an IPMI API call to get the value for this prop
            resourceProperty.add(coverOpenDoc);

            resourceProperty = resourcePropertySet.get(IpmiserverPropertyQNames.IPNAME);
            IpNameDocument ipNameDoc = IpNameDocument.Factory.newInstance();
            ipNameDoc.setIpName("MuwsMama");
            resourceProperty.add(ipNameDoc);

            resourceProperty = resourcePropertySet.get(IpmiserverPropertyQNames.MODELNAME);
            ModelNameDocument modelNameDoc = ModelNameDocument.Factory.newInstance();
            modelNameDoc.setModelName("PowerEdge 2850");
            resourceProperty.add(modelNameDoc);

            resourceProperty = resourcePropertySet.get(IpmiserverPropertyQNames.SERIALNUMBER);
            SerialNumberDocument serialNumberDoc = SerialNumberDocument.Factory.newInstance();
            serialNumberDoc.setSerialNumber("Z10007986D");
            resourceProperty.add(serialNumberDoc);

            resourceProperty = resourcePropertySet.get(IpmiserverPropertyQNames.SYSCONTACT);
            SysContactDocument sysContactDoc = SysContactDocument.Factory.newInstance();
            sysContactDoc.setSysContact("Eric Cartman");
            resourceProperty.add(sysContactDoc);

        }
        catch (Exception e)
        {
            throw new javax.xml.rpc.JAXRPCException("There was a problem in initializing your resource properties.  Please check your init() method. Cause: " + e.getLocalizedMessage());
        }
        // Resource Property {http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd}FixedTopicSet is implemented by the framework.
        // Resource Property {http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd}Topic is implemented by the framework.
        // Resource Property {http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd}TopicExpressionDialects is implemented by the framework.



        /**
         * This method call will make all resource properties be exposed
         * as Topics.  If you would like to change that behaviour you can
         * call TopicUtils.addResourcePropertyValueChangeTopic for each
         * Topic you'd like to expose property change notifications for.
         */
        try
        {
            org.apache.ws.notification.topics.util.TopicUtils.addResourcePropertyValueChangeTopics(getResourcePropertySet(), getTopicSpaceSet());
        }
        catch (Exception e)
        {
            throw new javax.xml.rpc.JAXRPCException("Unable to init the ResourceProperty Changed topics. Cause: " + e.getLocalizedMessage(), e);
        }

    }

}
