package org.apache.ws.resource.example.blackberry;

import org.apache.ws.resource.impl.AbstractResourceHome;

import javax.xml.namespace.QName;
import java.io.Serializable;
import java.util.Map;

/**
 * Home for Blackberry WS-Resources.
 */
public class BlackberryHome
        extends AbstractResourceHome
        implements Serializable
{
    /**
     * The service endpoint name as registered with the SOAP Platform.  This is useful for building EPR's. *
     */
    public static final QName SERVICE_NAME = javax.xml.namespace.QName.valueOf("{http://ws.apache.org/resource/example/blackberry}blackberry");

    /**
     * The management PortType associated with this resource. This is useful for building EPR's.*
     */
    public static final QName PORT_TYPE = javax.xml.namespace.QName.valueOf("{http://ws.apache.org/resource/example/blackberry}BlackberryPortType");

    /**
     * The WSDL Port name associated with the resource. This is useful for building EPR's. *
     */
    public static final String PORT_NAME = "blackberry";

    /**
     * The name of the resource key for this resource. *
     */
    public static final QName RESOURCE_KEY_NAME = javax.xml.namespace.QName.valueOf("{http://ws.apache.org/resource/example/blackberry}ResourceID");

    /**
     * A NamespaceVerionHolder which maintains the QNames of Spec Wsdls
     */
    public static final org.apache.ws.muws.v1_0.impl.WsdmNamespaceVersionHolderImpl SPEC_NAMESPACE_SET = new org.apache.ws.muws.v1_0.impl.WsdmNamespaceVersionHolderImpl();
    /**
     * A constant for the JNDI Lookup name for this home. *
     */
    public static final String HOME_LOCATION =
            org.apache.ws.resource.JndiConstants.CONTEXT_NAME_SERVICES + "/" + SERVICE_NAME.getLocalPart() + "/" + org.apache.ws.resource.JndiConstants.ATOMIC_NAME_HOME;

    private static final String BB1_ID = "bb1";
    private static final String BB2_ID = "bb2";

    public void init() throws Exception
    {
        super.init();
        add( createInstance( BB1_ID ) );
        add( createInstance( BB2_ID ) );
    }

    public QName getServiceName()
    {
        return SERVICE_NAME;
    }

    public QName getPortType()
    {
        return PORT_TYPE;
    }

    public String getServicePortName()
    {
        return PORT_NAME;
    }

    public QName getResourceKeyNameQName()
    {
        return RESOURCE_KEY_NAME;
    }

    /**
     * Map containing all FilesystemResource instances - this map <em>must</em> be static for
     * compatibility with certain JNDI providers.
     */
    private static Map s_resources;

    /**
     * Returns a map of all FilesystemResource instances. Used by the {@link org.apache.ws.resource.impl.AbstractResourceHome}
     * superclass.
     */
    protected synchronized final Map getResourceMap()
    {
        if ( s_resources == null )
        {
            s_resources = AbstractResourceHome.createResourceMap( m_resourceIsPersistent );
        }
        return s_resources;
    }
    public org.apache.ws.resource.properties.NamespaceVersionHolder getNamespaceVersionHolder()
    {
        return SPEC_NAMESPACE_SET;
    }

}
