package org.apache.ws.resource.example.blackberry;

import org.apache.ws.muws.v1_0.MuwsConstants;
import org.apache.ws.muws.v1_0.capability.ConfigurationCapability;
import org.apache.ws.muws.v1_0.capability.IdentityCapability;
import org.apache.ws.muws.v1_0.capability.MetricsCapability;
import org.apache.ws.muws.v1_0.capability.OperationalStatusCapability;
import org.apache.ws.muws.v1_0.topics.ManagementEventTopic;
import org.apache.ws.muws.v1_0.topics.impl.XmlBeansManagementEventTopicImpl;
import org.apache.ws.notification.topics.TopicSpace;
import org.apache.ws.notification.topics.impl.TopicSpaceImpl;
import org.oasisOpen.docs.wsdm.x2004.x12.muws.wsdmMuwsPart1.ManageabilityCapabilityDocument;
import org.oasisOpen.docs.wsdm.x2004.x12.muws.wsdmMuwsPart1.ResourceIdDocument;
import org.oasisOpen.docs.wsdm.x2004.x12.muws.wsdmMuwsPart2.CurrentTimeDocument;
import org.oasisOpen.docs.wsdm.x2004.x12.muws.wsdmMuwsPart2.OperationalStatusDocument;
import rim.pda.AllocatedStorageDocument;
import rim.pda.DateDocument;
import rim.pda.FreeStorageDocument;
import rim.pda.TimeDocument;
import rim.pda.TotalCodeModuleSizeDocument;

import java.util.Calendar;

/**
 * A Blackberry WS-Resource.
 * <p/>
 * NOTE: This class is generated but IS meant to be modified.
 */
public class BlackberryResource extends AbstractBlackberryResource

{
    /**
     * A NamespaceVerionHolder which maintains the QNames of Spec Wsdls
     */
    public static final org.apache.ws.notification.base.v2004_06.impl.WsnNamespaceVersionHolderImpl SPEC_NAMESPACE_SET = new org.apache.ws.notification.base.v2004_06.impl.WsnNamespaceVersionHolderImpl();

    /**
     * Initializes this resource's state (properties, etc.).
     */
    public void init()
    {
        super.init();

        /**
         * The ResourcePropertySet which contains all the defined ResourceProperties
         */
        org.apache.ws.resource.properties.ResourcePropertySet resourcePropertySet = getResourcePropertySet();
        org.apache.ws.resource.properties.ResourceProperty resourceProperty = null;

        try
        {
            /** Capabilities **/
            //Management Characteristics
            resourceProperty = resourcePropertySet.get(BlackberryPropertyQNames.MANAGEABILITYCAPABILITY);

            //Identity Capability
            ManageabilityCapabilityDocument manageabilityCapabilityDocument = ManageabilityCapabilityDocument.Factory.newInstance();
            manageabilityCapabilityDocument.setManageabilityCapability(IdentityCapability.URI);
            resourceProperty.add(manageabilityCapabilityDocument);

            //MUWS2 Metrics Capability
            manageabilityCapabilityDocument = ManageabilityCapabilityDocument.Factory.newInstance();
            manageabilityCapabilityDocument.setManageabilityCapability(MetricsCapability.URI);
            resourceProperty.add(manageabilityCapabilityDocument);

            //Blackberry Metrics Capability
            manageabilityCapabilityDocument = ManageabilityCapabilityDocument.Factory.newInstance();
            manageabilityCapabilityDocument.setManageabilityCapability("http://pda.rim/BlackberryMetrics");
            resourceProperty.add(manageabilityCapabilityDocument);

            //Configuration
            manageabilityCapabilityDocument = ManageabilityCapabilityDocument.Factory.newInstance();
            manageabilityCapabilityDocument.setManageabilityCapability(ConfigurationCapability.URI);
            resourceProperty.add(manageabilityCapabilityDocument);

            //Blackberry Configuration Capability
            manageabilityCapabilityDocument = ManageabilityCapabilityDocument.Factory.newInstance();
            manageabilityCapabilityDocument.setManageabilityCapability("http://pda.rim/BlackberryConfiguration");
            resourceProperty.add(manageabilityCapabilityDocument);

            //Status Capability
            manageabilityCapabilityDocument = ManageabilityCapabilityDocument.Factory.newInstance();
            manageabilityCapabilityDocument.setManageabilityCapability(OperationalStatusCapability.URI);
            resourceProperty.add(manageabilityCapabilityDocument);


            /** Topics **/
            //MUWS TopicSpace
            TopicSpace muwsTopicSpace = new TopicSpaceImpl(MuwsConstants.NSURI_MUWS_PART2_TOPICS);
            getTopicSpaceSet().addTopicSpace(muwsTopicSpace);

            ManagementEventTopic operationalStatusCapability = new XmlBeansManagementEventTopicImpl("OperationalStatusCapability");
            muwsTopicSpace.addTopic(operationalStatusCapability);
            ManagementEventTopic metricsCapability = new XmlBeansManagementEventTopicImpl("MetricsCapability");
            muwsTopicSpace.addTopic(metricsCapability);
            ManagementEventTopic codeModuleSize = new XmlBeansManagementEventTopicImpl("CodeModuleSize");

            //Blackberry TopicSpace
            TopicSpace bbryTopicSpace = new TopicSpaceImpl(BlackberryPropertyQNames.ALLOCATEDSTORAGE.getNamespaceURI());
            getTopicSpaceSet().addTopicSpace(bbryTopicSpace);
            bbryTopicSpace.addTopic(codeModuleSize);

            /** Properties **/
            resourceProperty = resourcePropertySet.get(BlackberryPropertyQNames.RESOURCEID);
            ResourceIdDocument resourceIdDocument = ResourceIdDocument.Factory.newInstance();
            resourceIdDocument.setResourceId("urn:" + (String) getID());
            resourceProperty.add(resourceIdDocument);

            resourceProperty = resourcePropertySet.get(BlackberryPropertyQNames.ALLOCATEDSTORAGE);
            AllocatedStorageDocument allocatedStorageDocument = AllocatedStorageDocument.Factory.newInstance();
            allocatedStorageDocument.setAllocatedStorage(1024);
            resourceProperty.add(allocatedStorageDocument);
            resourceProperty.addChangeListener(metricsCapability);

            //Calendar for use in a few properties
            Calendar calendarInstance = Calendar.getInstance();


            //current time is done like in WSRF
            resourceProperty = resourcePropertySet.get(BlackberryPropertyQNames.CURRENTTIME);
            CurrentTimeDocument currentTimeDocument = CurrentTimeDocument.Factory.newInstance();
            currentTimeDocument.setCurrentTime(calendarInstance);
            resourceProperty.add(currentTimeDocument);
            resourceProperty.setCallback(new org.apache.ws.resource.lifetime.callback.CurrentTimeCallback());
            resourceProperty.addChangeListener(metricsCapability);

            resourceProperty = resourcePropertySet.get(BlackberryPropertyQNames.DATE);
            DateDocument dateDocument = DateDocument.Factory.newInstance();
            DateDocument.Date date = dateDocument.addNewDate();
            date.setDay(calendarInstance.get(Calendar.DAY_OF_MONTH));
            date.setMonth(calendarInstance.get(Calendar.MONTH));
            date.setYear(calendarInstance.get(Calendar.YEAR));
            dateDocument.setDate(date);
            resourceProperty.add(dateDocument);


            resourceProperty = resourcePropertySet.get(BlackberryPropertyQNames.FREESTORAGE);
            FreeStorageDocument freeStorageDocument = FreeStorageDocument.Factory.newInstance();
            freeStorageDocument.setFreeStorage(384);
            resourceProperty.add(freeStorageDocument);
            resourceProperty.addChangeListener(metricsCapability);


            resourceProperty = resourcePropertySet.get(BlackberryPropertyQNames.OPERATIONALSTATUS);
            OperationalStatusDocument operationalStatusDocument = OperationalStatusDocument.Factory.newInstance();
            operationalStatusDocument.setOperationalStatus(OperationalStatusDocument.OperationalStatus.AVAILABLE);
            resourceProperty.add(operationalStatusDocument);
            resourceProperty.addChangeListener(operationalStatusCapability);

            resourceProperty = resourcePropertySet.get(BlackberryPropertyQNames.TIME);
            TimeDocument timeDocument = TimeDocument.Factory.newInstance();
            TimeDocument.Time time = timeDocument.addNewTime();
            time.setHour(calendarInstance.get(Calendar.HOUR_OF_DAY));//24 hr clock..no indication in spec
            time.setMinute(calendarInstance.get(Calendar.MINUTE));
            resourceProperty.add(timeDocument);

            resourceProperty = resourcePropertySet.get(BlackberryPropertyQNames.TOTALCODEMODULESIZE);
            TotalCodeModuleSizeDocument totalCodeModuleSizeDocument = TotalCodeModuleSizeDocument.Factory.newInstance();
            totalCodeModuleSizeDocument.setTotalCodeModuleSize(256);
            resourceProperty.add(totalCodeModuleSizeDocument);
            resourceProperty.addChangeListener(codeModuleSize);
            resourceProperty.addChangeListener(metricsCapability);
        }
        catch (Exception e)
        {
            throw new javax.xml.rpc.JAXRPCException("There was a problem in initializing your resource properties.  Please check your init() method. Cause: " + e.getLocalizedMessage());
        }
        // Resource Property {http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd}FixedTopicSet is implemented by the framework.
        // Resource Property {http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd}Topic is implemented by the framework.
        // Resource Property {http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd}TopicExpressionDialects is implemented by the framework.



        /**
         * This method call will make all resource properties be exposed
         * as Topics.  If you would like to change that behaviour you can
         * call TopicUtils.addResourcePropertyValueChangeTopic for each
         * Topic you'd like to expose property change notifications for.
         */
        try
        {
            org.apache.ws.notification.topics.util.TopicUtils.addResourcePropertyValueChangeTopics(getResourcePropertySet(), getTopicSpaceSet());
        }
        catch (Exception e)
        {
            throw new javax.xml.rpc.JAXRPCException("Unable to init the ResourceProperty Changed topics. Cause: " + e.getLocalizedMessage(), e);
        }

    }

}
