/*=============================================================================*
 *  Copyright 2005 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package org.apache.xmlbeans;

import junit.framework.TestCase;
import org.apache.xmlbeans.impl.store.Saaj;
import org.apache.xmlbeans.impl.xb.xsdschema.SchemaDocument;
import org.oasisOpen.docs.wsrf.x2004.x06.wsrfWSResourceProperties12Draft01.QueryExpressionDocument;

import javax.xml.soap.SOAPEnvelope;
import java.io.File;

/**
 * TODO
 */
public class FeatureTester extends TestCase
{

    public void testSaajProxy() throws Exception
    {
        XmlOptions xmlOpts = new XmlOptions();
        xmlOpts.put( Saaj.SAAJ_IMPL, new Object() );
        XmlObject xBean = XmlObject.Factory.parse(
                new File( "C:\\Projects\\Apache\\WSRF\\trunk\\src\\site\\content\\tutorial\\requests\\Destroy.soap" ),
                xmlOpts );
        assertTrue( xBean instanceof SOAPEnvelope );
    }

    public void testGetSchemaSourceName() throws Exception
    {
        QueryExpressionDocument xBean = QueryExpressionDocument.Factory.newInstance();
        String schemaName = xBean.schemaType().getSourceName();
        String schemaPath = "schema/src/" + schemaName;
        ClassLoader classLoader = Thread.currentThread().getContextClassLoader();
        XmlObject schemaXBean = XmlObject.Factory.parse( classLoader.getResourceAsStream( schemaPath ) );
        assertTrue( schemaXBean instanceof SchemaDocument );
    }

}
