/*=============================================================================*
 *  Copyright 2004 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package org.apache.ws.mows.v1_0.capability;

import org.apache.ws.mows.v1_0.MowsConstants;
import javax.xml.namespace.QName;

/**
 * The MOWS Metrics manageability capability.
 */
public interface MetricsCapability
{
   /**
    * Name of this capability.
    */
   String NAME = "Metrics";

   /**
    * Manageability capability URI.
    */
   String URI = MowsConstants.BASE_URI_MOWS_CAPABILITIES + NAME;

   /**
    * Port type name.
    */
   QName PORT_TYPE_NAME =
      new QName( MowsConstants.NSURI_MOWS_WSDL, "EndpointMetrics", MowsConstants.NSPREFIX_MOWS_WSDL );

   /**
    * Topic name.
    */
   String TOPIC_NAME = NAME + "Capability";

   /**
    * NumberOfRequests property name.
    */
   QName PROP_NAME_NUMBER_OF_REQUESTS =
      new QName( MowsConstants.NSURI_MOWS_SCHEMA, "NumberOfRequests", MowsConstants.NSPREFIX_MOWS_SCHEMA );

   /**
    * NumberOfSuccessfulRequests property name.
    */
   QName PROP_NAME_NUMBER_OF_SUCCESSFUL_REQUESTS =
      new QName( MowsConstants.NSURI_MOWS_SCHEMA, "NumberOfSuccessfulRequests", MowsConstants.NSPREFIX_MOWS_SCHEMA );

   /**
    * NumberOfFailedRequests property name.
    */
   QName PROP_NAME_NUMBER_OF_FAILED_REQUESTS =
      new QName( MowsConstants.NSURI_MOWS_SCHEMA, "NumberOfFailedRequests", MowsConstants.NSPREFIX_MOWS_SCHEMA );

   /**
    * ServiceTime property name.
    */
   QName PROP_NAME_SERVICE_TIME =
      new QName( MowsConstants.NSURI_MOWS_SCHEMA, "ServiceTime", MowsConstants.NSPREFIX_MOWS_SCHEMA );

   /**
    * MaxResponseTime property name.
    */
   QName PROP_NAME_MAX_RESPONSE_TIME =
      new QName( MowsConstants.NSURI_MOWS_SCHEMA, "MaxResponseTime", MowsConstants.NSPREFIX_MOWS_SCHEMA );

   /**
    * LastResponseTime property name.
    */
   QName PROP_NAME_LAST_RESPONSE_TIME =
      new QName( MowsConstants.NSURI_MOWS_SCHEMA, "LastResponseTime", MowsConstants.NSPREFIX_MOWS_SCHEMA );
}