/*=============================================================================*
 *  Copyright 2004 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package org.apache.ws.mows.v1_0.capability;

import org.apache.ws.mows.v1_0.MowsConstants;

/**
 * The MOWS RequestProcessingState manageability capability.
 */
public interface RequestProcessingStateCapability
{
   /**
    * Name of this capability.
    */
   String NAME = "RequestProcessingState";

   /**
    * Manageability capability URI.
    */
   String URI = MowsConstants.BASE_URI_MOWS_CAPABILITIES + NAME;

   /**
    * Topic name.
    */
   String TOPIC_NAME = NAME + "Capability";
}