/*=============================================================================*
 *  Copyright 2004 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package org.apache.ws.muws.tool;

import org.apache.velocity.VelocityContext;
import org.apache.ws.mows.tool.v1_0.ManageabilityReferencesPortType2JavaInfo;
import org.apache.ws.muws.tool.v1_0.RelationshipsPortType2JavaInfo;
import org.apache.ws.muws.v1_0.impl.WsdmNamespaceVersionHolderImpl;
import org.apache.ws.notification.tool.WsnWsdl2Java;
import org.apache.ws.resource.ResourceDefinition;
import org.apache.ws.resource.tool.velocity.ServiceProperties;
import java.io.File;

/**
 * Generates Java Web service types and skeletons from a WSRF/WSN/MUWS WSDL.
 *
 * @author Sal Campana
 */
public class MuwsWsdl2Java
   extends WsnWsdl2Java
{
   /** DOCUMENT_ME */
   protected String WEBAPP_NAME = "muse";

   /**
    * Creates a new {@link MuwsWsdl2Java} object.
    *
    * @param wsdlFiles DOCUMENT_ME
    * @param outputDir DOCUMENT_ME
    * @param classpath DOCUMENT_ME
    * @param options DOCUMENT_ME
    *
    * @throws Exception DOCUMENT_ME
    */
   public MuwsWsdl2Java( File[]           wsdlFiles,
                         File             outputDir,
                         File[]           classpath,
                         Wsdl2JavaOptions options )
   throws Exception
   {
      super( wsdlFiles, outputDir, classpath, options );
      initPortTypeInfoMap(  );
   }

   /**
    * DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   protected String getWebbappName(  )
   {
      return WEBAPP_NAME;
   }

   /**
    * DOCUMENT_ME
    *
    * @param resourceDefinition DOCUMENT_ME
    * @param file DOCUMENT_ME
    * @param file1 DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   protected ServiceProperties buildServiceProperties( ResourceDefinition resourceDefinition,
                                                       File               file,
                                                       File               file1 )
   {
      ServiceProperties serviceProperties = super.buildServiceProperties( resourceDefinition, file, file1 );
      serviceProperties.setNamespaceVersionHolder( WsdmNamespaceVersionHolderImpl.class ); //make sure to add different ones as new versions comeout
      return serviceProperties;
   }

   /**
    * Provides a hook for adding to the Velocity Context.
    *
    * @param context
    * @return VelocityContext
    */
   protected VelocityContext updateVelocityContext( VelocityContext    context,
                                                    ResourceDefinition resourceDef )
   {
      return super.updateVelocityContext( context, resourceDef );
   }

   private void initPortTypeInfoMap(  )
   {
      addPortType2JavaInfo( new RelationshipsPortType2JavaInfo(  ) );
      addPortType2JavaInfo( new ManageabilityReferencesPortType2JavaInfo(  ) );
   }
}