/*=============================================================================*
 *  Copyright 2004 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package org.apache.ws.muws.v1_0.capability;

import org.apache.ws.muws.v1_0.MuwsConstants;
import javax.xml.namespace.QName;

/**
 * The MUWS RelationshipResource manageability capability.
 */
public interface RelationshipResourceCapability
{
   /**
    * Name of this capability.
    */
   String NAME = "RelationshipResource";

   /**
    * Manageability capability URI.
    */
   String URI = MuwsConstants.BASE_URI_MUWS_CAPABILITIES + NAME;

   /**
    * Port type name.
    */
   QName PORT_TYPE_NAME =
      new QName( MuwsConstants.NSURI_MUWS_PART2_WSDL, NAME, MuwsConstants.NSPREFIX_MUWS_PART2_WSDL );

   /**
    * Topic name.
    */
   String TOPIC_NAME = NAME + "Capability";

   /**
    * Name property name.
    */
   QName PROP_NAME_NAME =
      new QName( MuwsConstants.NSURI_MUWS_PART2_SCHEMA, "Name", MuwsConstants.NSPREFIX_MUWS_PART2_SCHEMA );

   /**
    * Type property name.
    */
   QName PROP_NAME_TYPE =
      new QName( MuwsConstants.NSURI_MUWS_PART2_SCHEMA, "Type", MuwsConstants.NSPREFIX_MUWS_PART2_SCHEMA );

   /**
    * Participant property name.
    */
   QName PROP_NAME_PARTICIPANT =
      new QName( MuwsConstants.NSURI_MUWS_PART2_SCHEMA, "Participant", MuwsConstants.NSPREFIX_MUWS_PART2_SCHEMA );
}