/*=============================================================================*
 *  Copyright 2004 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package org.apache.ws.muws.v1_0.capability;

import org.apache.ws.muws.v1_0.MuwsConstants;
import javax.xml.namespace.QName;

/**
 * @author Sal Campana
 */
public interface StateCapability
{
   /**
    * Name of this capability.
    */
   String NAME = "State";

   /**
    * Manageability capability URI.
    */
   String URI = MuwsConstants.BASE_URI_MUWS_CAPABILITIES + NAME;

   /**
    * Topic name.
    */
   String TOPIC_NAME = NAME + "Capability";

   /**
    * OperationalStatus property name.
    */
   QName PROP_NAME_STATE =
      new QName( MuwsConstants.NSURI_MUWS_PART2_SCHEMA, "State", MuwsConstants.NSPREFIX_MUWS_PART2_SCHEMA );
}