/*=============================================================================*
 *  Copyright 2004 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package org.apache.ws.muws.v1_0.events.impl;

import org.apache.ws.XmlObjectWrapper;
import org.apache.ws.muws.v1_0.events.SubstitutableMsg;
import org.apache.xmlbeans.XmlObject;
import org.oasisOpen.docs.wsdm.x2004.x12.muws.wsdmMuwsPart2.SubstitutableMsgType;
import java.util.ArrayList;
import java.util.List;

/**
 * @author Sal Campana
 */
public class SubstitutableMsgImpl
   implements SubstitutableMsg,
              XmlObjectWrapper
{
   private String m_messageId;
   private String m_msgType;
   private List   m_values = new ArrayList(  );

   /**
    * DOCUMENT_ME
    *
    * @param messageId DOCUMENT_ME
    */
   public void setMsgId( String messageId )
   {
      m_messageId = messageId;
   }

   /**
    * DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public String getMsgId(  )
   {
      return m_messageId;
   }

   /**
    * DOCUMENT_ME
    *
    * @param msgType DOCUMENT_ME
    */
   public void setMsgType( String msgType )
   {
      m_msgType = msgType;
   }

   /**
    * DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public String getMsgType(  )
   {
      return m_msgType;
   }

   /**
    * DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public String[] getValueArray(  )
   {
      return (String[]) m_values.toArray( new String[0] );
   }

   /**
    * DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public XmlObject getXmlObject(  )
   {
      SubstitutableMsgType substitutableMsgType = SubstitutableMsgType.Factory.newInstance(  );
      substitutableMsgType.setMsgId( m_messageId );
      substitutableMsgType.setMsgIdType( m_msgType );
      for ( int i = 0; i < m_values.size(  ); i++ )
      {
         String                               s                = (String) m_values.get( i );
         org.apache.xmlbeans.XmlAnySimpleType xmlAnySimpleType = substitutableMsgType.addNewValue(  );
         xmlAnySimpleType.setStringValue( s );
      }

      return substitutableMsgType;
   }

   /**
    * DOCUMENT_ME
    *
    * @param value DOCUMENT_ME
    */
   public void addValue( String value )
   {
      m_values.add( value );
   }
}