/*=============================================================================*
 *  Copyright 2004 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package org.apache.ws.muws.v1_0.topics;

import org.apache.ws.muws.v1_0.events.ManagementEvent;
import org.apache.ws.notification.topics.ResourcePropertyValueChangeTopic;
import org.apache.ws.notification.topics.Topic;

/**
 * @author Sal Campana
 */
public interface ManagementEventTopic
   extends Topic,
           ResourcePropertyValueChangeTopic
{
   /**
    * This method is used to send a ManagementEvent to subscribers to this topic.
    *
    * @param me
    */
   void publish( ManagementEvent me );
}